=== modified file 'README'
--- README	2010-01-29 14:09:05 +0000
+++ README	2010-10-07 06:08:01 +0000
@@ -36,7 +36,7 @@
 It also directly supports and encourages a large number of development best
 practices like refactoring and pre-commit regression testing. Users can
 choose between our command line tool and our cross-platform GUI application.
-For further details, see our website at http://bazaar-vcs.org/en.
+For further details, see our website at http://bazaar.canonical.com/en/
 
 Feedback
 ========

=== modified file 'doc/developers/cycle.txt'
--- doc/developers/cycle.txt	2010-01-08 00:44:26 +0000
+++ doc/developers/cycle.txt	2010-10-12 15:50:39 +0000
@@ -2,7 +2,7 @@
 Bazaar Release Cycles
 *********************
 
-:status: Current policy, as of 2009-08.
+:status: Current policy, as of 2010-10.
 :blueprint: <https://blueprints.launchpad.net/bzr/+spec/6m-cycle>
 
 
@@ -10,7 +10,7 @@
 core product. They also want a Just Works experience across the full
 Bazaar ecosystem. To deliver the first and enable the second, we're
 adopting some standard process patterns: a 6 monthly release cycle and a
-stable branch. These changes will also have other benefits, including
+stable series. These changes will also have other benefits, including
 better availability of bug fixes in OS distributions, more freedom to
 remove old code, and less work for in packaging.
 
@@ -25,11 +25,11 @@
 The Process
 ************
 
-Bazaar will make a major release every six months, which will be supported
-at least until the time of the next major release.  During this support
-period, we'll make incremental releases which fix bugs, but which do not
-change network or disk formats or command syntax, and which do not require
-updates to plugins.
+Bazaar will make a major release every six months, which will be supported at
+least until the time of the next major release and generally 18 months after
+the first final release in a series.  During this support period, we'll make
+incremental releases which fix bugs, but which do not change network or disk
+formats or command syntax, and which do not require updates to plugins.
 
 We will also run a development series, which will become the next major
 release.  We'll make a beta release from this every four weeks.  The
@@ -75,15 +75,6 @@
 often if there are serious bugs, perhaps much less often if no new changes
 have landed.
 
-We will then make a release candidate for the next major release, and at
-this point create a release branch for it.  We will iterate release
-candidates at approximately weekly intervals until there are no bugs
-blocking the final major release.
-
-Compared to the current process this has approximately the same amount of
-release-related work, because the extra releases from the stable branch
-are "paid for" by not doing RCs for the development series.
-
 We will synchronize our major releases with Ubuntu, so that they come out
 in sufficient time for some testing and margin of error before Ubuntu's
 upstream freeze.
@@ -118,32 +109,40 @@
 -----------
 
 Major releases (2.0.0 or 2.1.0)
+
     The big ones, every six months, intended to ship in distributions and
     to be used by stability-oriented users.
 
 Release candidate (2.0.0rc1)
-    A preview of a major release, made one or a few weeks beforehand at
-    the time the release branch is created.  There should be few if any
-    changes from the rc to the stable release.  We should avoid the
-    confusing phrasing "release candidate 2.0.0rc1 is released"; instead
-    use "available."
+
+    A preview of a major release, made one or a few weeks beforehand at the
+    time the release branch is created.  There should be few if any changes
+    from the rc to the stable release.  We should avoid the confusing phrasing
+    "release candidate 2.0.0rc1 is released"; instead use "available."
+    Starting with the 2.3 series we don't plan on making release candidates
+    anymore.
 
 Bugfix releases (2.0.1)
+
     Based on the previous major release or bugfix; contains only bugfixes
     and perhaps documentation or translation corrections.
 
 Stable series
+
     A major release and its descendant bugfix releases.
 
 Stable release
+
     Either a major release or a bugfix release.
 
 Beta release (3.0.0beta1)
+
     Made from trunk every month, except for the month there's a major
     release.  Stable and suitable for users who want the latest code and
     can live with some changes from month to month.
 
 Development series
+
     The development releases leading up to a stable release.
 
 Bug Work
@@ -183,8 +182,8 @@
 Plugins that want to cooperate with this should make a series and a branch
 that matches each bzr stable series, and follow similar rules in making
 releases from their stable branch.  We'd expect that plugins will make a
-release between the last development release of a series and the major
-release candidate.
+release between the first beta release of a series and the final major
+release.
 
 Within a stable series, anything that breaks any known plugin is
 considered an API break and will be avoided.  Before
@@ -274,11 +273,11 @@
 Packaging
 ---------
 
-At present we have three upstream-maintained PPAs containing Ubuntu
-packages of Bazaar: ``~bzr-nightly-ppa``, ``~bzr-beta-ppa`` (rcs and
-releases) and ``~bzr`` (ie stable).  We will keep these PPAs, and reorient
-beta to contain the monthly beta releases, and the stable PPA to contain
-stable releases, their release candidates, and bugfixes to those releases.
+At present we have three upstream-maintained PPAs containing Ubuntu packages
+of Bazaar: ``~bzr-nightly-ppa``, ``~bzr-beta-ppa`` (beta releases) and
+``~bzr`` (ie stable).  We will keep these PPAs, and reorient beta to contain
+the monthly beta releases, and the stable PPA to contain stable releases and
+bugfixes to those releases.
 
 Some platforms with relatively less active packagers may choose to ship
 only the stable releases.  This is probably better than having them only

=== modified file 'doc/developers/ppa.txt'
--- doc/developers/ppa.txt	2010-09-20 12:05:38 +0000
+++ doc/developers/ppa.txt	2010-10-12 15:50:39 +0000
@@ -68,6 +68,8 @@
 * Hardy LTS
 * Dapper LTS (supported but no longer updated for new releases)
 
+The ``rmadison bzr`` command will gives you an up-to-date summary
+of which bzr releases are current in each Ubuntu release.
 
 Preconditions
 -------------

=== modified file 'doc/developers/releasing.txt'
--- doc/developers/releasing.txt	2010-10-13 06:04:10 +0000
+++ doc/developers/releasing.txt	2010-10-13 08:08:58 +0000
@@ -2,10 +2,12 @@
 ################
 
 This document describes the processes for making and announcing a Bazaar
-release, and managing the release process.  This is just one phase of the
-`overall development cycle <http://doc.bazaar.canonical.com/developers/cycle.html>`_,
-but it's the most complex part.  This document gives a checklist you can
-follow from start to end in one go.
+release, and managing the release process.  This is just one phase of
+the `overall development cycle
+<http://doc.bazaar.canonical.com/developers/cycle.html>`_, (go re-read
+this document to ensure it hasn't been updated) but it's the most
+complex part.  This document gives a checklist you can follow from start
+to end in one go.
 
 If you're helping the Release Manager (RM) for one reason or another, you
 may notice that he didn't follow that document scrupulously. He may have
@@ -25,6 +27,56 @@
      bzr branch lp:bzr-pqm ~/.bazaar/plugins/pqm
 
 
+When do we relase ?
+===================
+
+As of October 2010, we mantain four series.  Concurrently releasing them
+all at the same time makes it harder to shorten the delay between the
+source availability and the package building longer than necessary (we
+delay the official announcement until most of our users can install the new
+release).
+
+In order to continue to do time-based releases, we need to plan the
+releases by series to minimize the collisions. In the end, it's the Release
+Manager call to decide whether he prefers to do all releases at once
+though, so the rules presented here are a conservative approach.
+
+We want to respect the following rules::
+
+ #. as much as possible releases should not disturb development, and
+    ongoing development should not disturb releases,
+
+ #. the most recent development series should release once a month during
+    the beta period (see `Development cycles <cycle.html>`_ for more
+    details),
+
+ #. the most recent stable series should release every other month (based
+    on the amount of bug fixes, this can be shorter or longer depending on
+    the bugs importance),
+
+ #. previous series should relesase on a regular basis without interfering
+    with the most recent series with a decreasing order of priority (again
+    this should be based on bugs importance and user feedback),
+
+ #. the death of a series should be planned ahead of time. 6 months should
+    give enough time to our users to migrate to a more recent series. This
+    doesn't mean we will make a release at the end of the series, just that
+    before the end date we _could_ possibly put out another release if
+    there was a sufficiently important fix.  Beyond that date, we won't
+    even land changes on that branch (unless something causes a miraculous
+    resurrection.)
+
+ #. there should not be more than 2 releases in the same week (but the
+    Release Manager is free to ignore this (get in touch with packagers
+    though),
+
+ #. the series are aligned with Ubuntu releases for convenience since we
+    create a new series every 6 months. This means that we support the
+    stable series for 18 months. Note that we also propose the most recent
+    stable series via the ppa, so whether we keep supporting LTS directly
+    or via the ppa is still an open question.
+
+
 At the start of a release cycle
 ===============================
 
@@ -187,6 +239,9 @@
 
       # API compatibility version: bzrlib is currently API compatible with 1.7.
 
+   Note that the NEWS file formatting has evolved, this example needs to
+   be updated.
+
 #. Tag the new release::
 
      bzr tag bzr-1.14
@@ -242,16 +297,18 @@
    this changes what the download widget on the Launchpad bzr home
    page shows, so don't stop the release process yet, or platform binary
    installers won't be made and the download list will stay very small!
-   <https://bugs.edge.launchpad.net/launchpad/+bug/586445>
+   <https://bugs.launchpad.net/launchpad/+bug/586445>
 
 
 Announcing the source freeze
 ----------------------------
 
-#. Post to the ``bazaar`` list, saying that the source has been frozen.
-   This is the cue for platform maintainers and plugin authors to update
-   their code.  This is done before the general public announcement of the
-   release.
+#. Post to the ``bazaar`` list, saying that the source has been frozen
+   (gone gold). Be extra clear that this is only a *source* release
+   targeted at packagers and installer builders (see
+   <https://bugs.launchpad.net/launchpad/+bug/645084>).  This is the cue
+   for platform maintainers and plugin authors to update their code.  This
+   is done before the general public announcement of the release.
 
 
 Kick off the next cycle
@@ -307,12 +364,12 @@
 
       Subject: bzr x.y.z released!
 
-      <<Summary paragraph from news>>
-
       The Bazaar team is happy to announce availability of a new
       release of the bzr adaptive version control system.
       Bazaar is part of the GNU system <http://gnu.org/>.
 
+      <<Summary paragraph from news>>
+
       Thanks to everyone who contributed patches, suggestions, and
       feedback.
 
@@ -343,7 +400,8 @@
 
        python setup.py register
 
-   Remember to check the results afterwards.
+   Remember to check the results afterwards -- this should be done for
+   final releases but not for beta releases or Release Candidates.
 
    To be able to register the release you must create an account on
    <http://pypi.python.org/pypi> and have one of the existing owners of

=== modified file 'doc/en/release-notes/bzr-2.2.txt'
--- doc/en/release-notes/bzr-2.2.txt	2010-10-13 00:43:19 +0000
+++ doc/en/release-notes/bzr-2.2.txt	2010-10-13 08:08:58 +0000
@@ -19,6 +19,31 @@
 Bug Fixes
 *********
 
+* Using bzr with `lp:` urls behind an http proxy should work.
+  (Robert Collins, #558343)
+
+Improvements
+************
+
+Documentation
+*************
+
+API Changes
+***********
+
+Internals
+*********
+
+Testing
+*******
+
+* Add ``tests/ssl_certs/ca.crt`` to the required test files list. Test
+  involving the pycurl https test server fail otherwise when running
+  selftest from an installed version. (Vincent Ladeuil, #651706)
+
+* Fix tests that failed when run under ``LANG=C``.
+  (Andrew Bennetts, #632387)
+
 * Skip tests that needs a bzr source tree when there isn't one. This is
   needed to succesfully run the test suite for installed versions.
   (Vincent Ladeuil, #644855).
@@ -27,31 +52,6 @@
   root. Including the one that wasn't present in 2.1.
   (Vincent Ladeuil, #646133)
 
-* Using bzr with `lp:` urls behind an http proxy should work.
-  (Robert Collins, #558343)
-
-Improvements
-************
-
-Documentation
-*************
-
-API Changes
-***********
-
-Internals
-*********
-
-Testing
-*******
-
-* Add ``tests/ssl_certs/ca.crt`` to the required test files list. Test
-  involving the pycurl https test server fail otherwise when running
-  selftest from an installed version. (Vincent Ladeuil, #651706)
-
-* Fix tests that failed when run under ``LANG=C``.
-  (Andrew Bennetts, #632387)
-
 
 bzr 2.2.1
 #########
@@ -671,9 +671,6 @@
   messages.
   (Parth Malwankar, #563646)
 
-* Using bzr with `lp:` urls behind an http proxy should work.
-  (Robert Collins, #558343)
-
 * When passing a file to ``UTF8DirReader`` make sure to close the current
   directory file handle after the chdir fails. Otherwise when passing many
   filenames into a command line ``bzr status`` we would leak descriptors.

=== modified file 'doc/en/release-notes/bzr-2.3.txt'
--- doc/en/release-notes/bzr-2.3.txt	2010-10-13 05:48:10 +0000
+++ doc/en/release-notes/bzr-2.3.txt	2010-10-13 08:08:58 +0000
@@ -10,8 +10,10 @@
 
 :2.3b3: NOT RELEASED YET
 
-Compatibility Breaks
-********************
+External Compatibility Breaks
+*****************************
+
+(none)
 
 New Features
 ************
@@ -31,6 +33,9 @@
   default format for new branches created with ``bzr init``.
   (Neil Martinsen-Burrell, #484101)
 
+Improvements
+************
+
 Bug Fixes
 *********
 
@@ -45,9 +50,6 @@
 
 * Make ``bzr tag --quiet`` really quiet. (Neil Martinsen-Burrell, #239523)
 
-Improvements
-************
-
 Documentation
 *************
 
@@ -70,8 +72,8 @@
 
 :2.3b2: 2010-10-08
 
-Compatibility Breaks
-********************
+External Compatibility Breaks
+*****************************
 
 * The ``bzr tags`` command sorts tag names using a natural sort by
   default (so tag2 sorts before tag10).  The previous default was
@@ -100,17 +102,32 @@
   Also, bzr will recognize if the 'ssh' comand is a symlink to lsh.
   (Matthew Gordon, #374700)
 
-* The ``pull`` and ``update`` commands now take a ``-show-base``
+* The ``pull`` and ``update`` commands now take a ``--show-base``
   option that, in the case of conflicts, shows the base revision text.
   (Rory Yorke,  #202374)
 
-Bug Fixes
-*********
+Improvements
+************
 
 * ``bzr break-lock --force`` breaks the lock without prompting.  (Before
   using this, make sure the process holding the lock really is dead.)
   (Martin Pool, #397315)
 
+* ``bzr remove`` now takes a ``--no-backup`` option for when you don't want it
+  to backup anything, just delete it. This option used to be called ``--force``
+  which is now deprecated.
+  (Marius Kruger, #400554)
+
+* When using the pycurl client module, Bazaar shows some of the text from
+  http server error messages.
+  (Martin Pool, #656667)
+
+Bug Fixes
+*********
+
+* Don't force openssh to use protocol=2, since that is now the default.
+  (Neil Martinsen-Burrell, #561061)
+
 * Fix signature of RemoteBzrDir.create_workingtree to match that of its
   superclass.  (Neil Martinsen-Burrell, Martin Pool, #524627)
 
@@ -121,31 +138,12 @@
   when using the rio format (with non-ascii information) on a non-utf-8
   terminal.  (Andrej A Antonov, #518609)
 
-* Skip tests that needs a bzr source tree when there isn't one. This is
-  needed to succesfully run the test suite for installed versions.
-  (Vincent Ladeuil, #644855).
-
-* Skip the tests that requires respecting the chmod bits when running as root.
-  (Vincent Ladeuil, #646133)
-
 * Treat all IO, OS, and socket errors consistently when establishing
   SSH/SFTP connections via a subprocess.  (Andrew Bennetts)
 
 * ``unshelve --preview`` now can show diff in a non-ascii encoding.
   (Andrej A Antonov, #518916)
 
-Improvements
-************
-
-* ``bzr remove`` now takes a ``--no-backup`` option for when you don't want it
-  to backup anything, just delete it. This option used to be called ``--force``
-  which is now deprecated.
-  (Marius Kruger, #400554)
-
-* When using the pycurl client module, Bazaar shows some of the text from
-  http server error messages.
-  (Martin Pool, #656667)
-
 Documentation
 *************
 
@@ -192,6 +190,13 @@
 * Fix tests that failed when run under ``LANG=C``.
   (Andrew Bennetts, #632387)
 
+* Skip tests that needs a bzr source tree when there isn't one. This is
+  needed to succesfully run the test suite for installed versions.
+  (Vincent Ladeuil, #644855).
+
+* Skip the tests that requires respecting the chmod bits when running as root.
+  (Vincent Ladeuil, #646133)
+
 * Suppress the "maximum recursion depth exceeded in __subclasscheck__"
   warning on stderr emitted during ``test_dict_deepnested`` in
   ``bzrlib/tests/test__bencode.py``.  (Andrew Bennetts)
@@ -221,140 +226,10 @@
 its own.
 
 
-Compatibility Breaks
-********************
-
-* BzrError subclasses no longer support the name "message" to be used
-  as an argument for __init__ or in _fmt format specification as this
-  breaks in some Python versions. errors.LockError.__init__ argument
-  is now named "msg" instead of earlier "message".
-  (Parth Malwankar, #603461)
-
-* Additional merges after an unrelated branch has been merged with its
-  history no longer crash when deleted files are involved.
-  (Vincent Ladeuil, John Arbash Meinel, #375898)
-
-* ``bzr add SYMLINK/FILE`` now works properly when the symlink points to a
-  previously-unversioned directory within the tree: the directory is
-  marked versioned too.
-  (Martin Pool, #192859)
-
-* ``bzr commit SYMLINK`` now works, rather than trying to commit the
-  target of the symlink.
-  (Martin Pool, John Arbash Meinel, #128562)
-
-* ``bzr upgrade`` now creates the ``backup.bzr`` directory with the same
-  permissions as ``.bzr`` directory on a POSIX OS.
-  (Parth Malwankar, #262450)
-
-* ``bzrlib.transform.TreeTransformBase.final_kind``,
-  ``bzrlib.transform.TreeTransform.tree_kind`` and
-  ``bzrlib.transform.TransformPreview.tree_kind`` now return None instead
-  of raising NoSuchFile.  (Vincent Ladeuil)
-
-* CommitBuilder now uses the committer instead of _config.username to generate
-  the revision-id.  (Aaron Bentley, #614404)
-
-* Configuration files in ``${BZR_HOME}`` are now written in an atomic
-  way which should help avoid problems with concurrent writers.
-  (Vincent Ladeuil, #525571)
-
-* `ControlDirFormat` and  `ControlDir` have been split out of `BzrDirFormat`
-  and `BzrDir`, respectively. `ControlDirFormat`
-  and `ControlDir` should be used as the base classes for new non-.bzr
-  implementations.
-
-  `BzrDirFormat.register_control_format` has been renamed to
-  `ControlDirFormat.register_format`.
-
-  `BzrDirFormat.register_server_control_format` has been removed.
-
-  Probing for control directories is now done by separate objects derived
-  from `bzrlib.controldir.Prober` and registered using
-  `bzrlib.controldir.ControlDirFormat.register_prober` or
-  `bzrlib.controldir.ControlDirFormat.register_server_prober`.
-  `BzrDirFormat.probe_transport` has been moved onto `Prober`.
-
-  `BzrDirFormat.register_format` has been renamed to
-  `BzrProber.register_bzrdir_format`.
-
-  `bzrlib.bzrdir.network_format_registry` has been moved to
-  `bzrlib.controldir`.
-
-  (Jelmer Vernooij)
-
-* Cope with Microsoft FTP server that returns reply '250 Directory
-  created' when mkdir succeeds.  (Martin Pool, #224373)
-
-* Don't traceback when a lockdir's ``held/info`` file is corrupt (e.g.
-  contains only NUL bytes).  Instead warn the user, and allow ``bzr
-  break-lock`` to remove it.  (Andrew Bennetts, #619872)
-  
-* `decode` parameter to get() method in FtpTransport and GioTransport classes
-  is deprecated. (Alexander Belchenko)
-
-* `FileInWrongBranch` is deprecated in favour of `PathNotChild` and no
-  longer raised.
-  (Martin Pool)
-
-* Fix ``AttributeError on parent.children`` when adding a file under a
-  directory that was a symlink in the previous commit.
-  (Martin Pool, #192859)
-
-* Fix ``AttributeError: 'NoneType' object has no attribute 'close'`` in
-  ``_close_ssh_proc`` when using ``bzr+ssh://``.  This was causing
-  connections to pre-1.6 bzr+ssh servers to fail, and causing warnings on
-  stderr in some other circumstances.  (Andrew Bennetts, #633745)
-
-* Only call ``setlocale`` in the bzr startup script on posix systems. This
-  avoids an issue with the newer windows C runtimes used by Python 2.6 and
-  later which can mangle bytestrings printed to the console.
-  (Martin [gz], #631350)
-
-* Prevent ``CHKMap.apply_delta`` from generating non-canonical CHK maps,
-  which can result in "missing referenced chk root keys" errors when
-  fetching from repositories with affected revisions.
-  (Andrew Bennetts, #522637)
-
-* Raise ValueError instead of a string exception.
-  (John Arbash Meinel, #586926)
-
-* Reduce peak memory by one copy of compressed text.
-  (John Arbash Meinel, #566940)
-
-* Repositories accessed via a smart server now reject being stacked on a
-  repository in an incompatible format, as is the case when accessing them
-  via other methods.  This was causing fetches from those repositories via
-  a smart server (e.g. using ``bzr branch``) to receive invalid data.
-  (Andrew Bennetts, #562380)
-
-* Selftest with versions of subunit that support ``stopTestRun`` will no longer
-  error. This error was caused by 2.0 not being updated when upstream
-  python merged the end of run patch, which chose ``stopTestRun`` rather than
-  ``done``. (Robert Collins, #571437)
-
-* Stop ``AttributeError: 'module' object has no attribute 'ElementTree'``
-  being thrown from ``xml_serializer`` on certain cElementTree setups.
-  (Martin [gz], #254278)
-
-* The old ``bzr selftest --benchmark`` option has been removed.
-  <https://launchpad.net/bzr-usertest> is an actively-maintained
-  macrobenchmark suite.
-  (Martin Pool)
-
-* `tree_files` and `internal_tree_files` are now deprecated in favor of
-  `WorkingTree.open_containing_paths`.
-  (Martin Pool)
-
-* Upgrading or fetching from a non-rich-root repository to a rich-root
-  repository (e.g. from pack-0.92 to 2a) no longer fails with
-  ``'Inter1and2Helper' object has no attribute 'source_repo'``.  This was
-  a regression from Bazaar 2.1.  (Andrew Bennetts, #636930)
-  
-* When passing a file to ``UTF8DirReader`` make sure to close the current
-  directory file handle after the chdir fails. Otherwise when passing many
-  filenames into a command line ``bzr status`` we would leak descriptors.
-  (John Arbash Meinel, #583486)
+External Compatibility Breaks
+*****************************
+
+(none)
 
 New Features
 ************
@@ -380,28 +255,96 @@
 * New development format ``development8-subtree`` which is similar to the 
   ``2a`` format and adds subtree support. (Jelmer Vernooij)
 
-Bug Fixes
-*********
+Improvements
+************
 
-* Allow using both --using and --diff-options. 
+* Allow using both ``--using`` and ``--diff-options``.
   (Matthäus G. Chajdas, #234708)
 
 * Allow using non-integer bug ID with generic bug trackers.
   (Alexandre Garnier, #440472)
 
+* ``bzr remove`` now just backs up changed files instead of exiting,
+  forcing you to choose to either keep or delete them. Bazaar will now delete
+  the files if they can easily be recovered using revert, otherwise they
+  will be backed up (adding an extention of the form .~#~).
+  (Marius Kruger, #400554)
+
+* ``bzr revert`` and ``bzr status`` are up to 15% faster on large trees
+  with many changes by not repeatedly building a list of all file-ids.
+  (Andrew Bennetts)
+
+* Decrease memory consumption when many chk index pages are loaded. (Such
+  as during ``bzr co`` or ``bzr ls -R`` of a large tree.) Often we need to
+  read many chk pages because the individual chk map nodes will be spread
+  randomly. Peak memory for 'bzr ls -R' on a large tree dropped from 396MB
+  down to 247MB, expect even more significant savings on 64-bit platforms.
+  (John Arbash Meinel)
+
+* Decrease peak memory during ``bzr send``. The old code was caching all
+  text content and all inventory strings for all revisions before
+  computing the diffs. Now we only cache as long as there is a child that
+  will need them. Sending 2000 bzr revisions drops from 1.2GB peak to
+  256MB peak. (John Arbash Meinel, #614576)
+
+* ``DirState`` internals use a little bit less memory. For bzr.dev it
+  drops the memory from 1MB down to about 800kB. And replaces a few
+  thousand tuples and sets with StaticTuple.  (John Arbash Meinel)
+
+* Inventory entries now consume less memory (on 32-bit Ubuntu file entries
+  have dropped from 68 bytes to 40, and directory entries from 120 bytes
+  to 48).  (Andrew Bennetts)
+
+* Reduce peak memory by one copy of compressed text when writing to pack
+  repositories.
+  (John Arbash Meinel, #566940)
+
+* When building new working trees, default to reading from the repository
+  rather than the source tree unless explicitly requested. (via
+  ``--files-from`` and ``--hardlink`` for ``bzr branch`` and
+  ``bzr checkout``. Generally, 2a format repositories extract
+  content faster than seeking and reading content from another tree,
+  especially in cold-cache situations. (John Arbash Meinel, #607298)
+
+* Add ``__pycache__`` to the default ``ignores`` file. Future releases of
+  Python will use this directory to store bytecodes.
+  (Andrea Corbellini, #626687)
+
+Bug Fixes
+*********
+
+* Additional merges after an unrelated branch has been merged with its
+  history no longer crash when deleted files are involved.
+  (Vincent Ladeuil, John Arbash Meinel, #375898)
+
 * ``bzr add SYMLINK/FILE`` now works properly when the symlink points to a
   previously-unversioned directory within the tree: the directory is
-  marked versioned too.  
+  marked versioned too.
   (Martin Pool, #192859)
 
+* ``bzr clean-tree`` issues a warning if it is unable to delete a file
+  due to ``errno.EACCES`` instead of exiting with an error on Windows.
+  (Parth Malwankar, #430785)
+
+* ``bzr commit SYMLINK`` now works, rather than trying to commit the
+  target of the symlink.
+  (Martin Pool, John Arbash Meinel, #128562)
+
 * ``bzr ignore PATTERNS`` exits with error if a bad pattern is supplied.
   ``InvalidPattern`` exception error message now shows faulting
   regular expression.
   (Parth Malwankar #300062)
 
-* ``clean-tree`` issues a warning if it is unable to delete a file
-  due to ``errno.EACCES`` instead of exiting with an error on Windows.
-  (Parth Malwankar, #430785)
+* ``bzr upgrade`` now creates the ``backup.bzr`` directory with the same
+  permissions as ``.bzr`` directory on a POSIX OS.
+  (Parth Malwankar, #262450)
+
+* CommitBuilder now uses the committer instead of _config.username to generate
+  the revision-id.  (Aaron Bentley, #614404)
+
+* Configuration files in ``${BZR_HOME}`` are now written in an atomic
+  way which should help avoid problems with concurrent writers.
+  (Vincent Ladeuil, #525571)
 
 * CommitBuilder now uses the committer instead of _config.username to generate
   the revision-id.  (Aaron Bentley, #614404)
@@ -412,11 +355,8 @@
 * Cope with Microsoft FTP Server and VSFTPd that return reply '250
   Directory created' when mkdir succeeds.  (Martin Pool, #224373)
 
-* Decrease peak memory during ``bzr send``. The old code was caching all
-  text content and all inventory strings for all revisions before
-  computing the diffs. Now we only cache as long as there is a child that
-  will need them. Sending 2000 bzr revisions drops from 1.2GB peak to
-  256MB peak. (John Arbash Meinel, #614576)
+* `decode` parameter to get() method in FtpTransport and GioTransport classes
+  is deprecated. (Alexander Belchenko)
 
 * Don't print internal object name when print an invalid revision spec
   error.  (Neil Martinsen-Burrell, #598701)
@@ -443,6 +383,20 @@
 * Fix spurious paramiko warning on hardy by ensuring that ``selftest``
   properly remove its warning filter. (Vincent Ladeuil, #625686)
 
+* Fix ``AttributeError on parent.children`` when adding a file under a
+  directory that was a symlink in the previous commit.
+  (Martin Pool, #192859)
+
+* Fix ``AttributeError: 'NoneType' object has no attribute 'close'`` in
+  ``_close_ssh_proc`` when using ``bzr+ssh://``.  This was causing
+  connections to pre-1.6 bzr+ssh servers to fail, and causing warnings on
+  stderr in some other circumstances.  (Andrew Bennetts, #633745)
+
+* Fix a problem in bzr's ``Makefile`` that meant syntax errors in some
+  parts of bzr's source code could cause ``make check-nodocs`` to
+  incorrectly return an exit code of 0.
+  (Vincent Ladeuil, #626667)
+
 * ``HTTP/1.1`` test servers now set a ``Content-Length`` header to comply
   with pedantic ``HTTP/1.1`` clients. (Vincent Ladeuil, #568421)
 
@@ -458,14 +412,29 @@
 * `PathNotChild` should not give a traceback.
   (Martin Pool, #98735)
 
-* ``PQM`` will no longer ignore syntax errors in submissions.
-  (Vincent Ladeuil, #626667)
-
 * Prevent ``CHKMap.apply_delta`` from generating non-canonical CHK maps,
   which can result in "missing referenced chk root keys" errors when
   fetching from repositories with affected revisions.
   (Andrew Bennetts, #522637)
 
+* Raise ValueError instead of a string exception.
+  (John Arbash Meinel, #586926)
+
+* Repositories accessed via a smart server now reject being stacked on a
+  repository in an incompatible format, as is the case when accessing them
+  via other methods.  This was causing fetches from those repositories via
+  a smart server (e.g. using ``bzr branch``) to receive invalid data.
+  (Andrew Bennetts, #562380)
+
+* Selftest with versions of subunit that support ``stopTestRun`` will no longer
+  error. This error was caused by 2.0 not being updated when upstream
+  python merged the end of run patch, which chose ``stopTestRun`` rather than
+  ``done``. (Robert Collins, #571437)
+
+* Stop ``AttributeError: 'module' object has no attribute 'ElementTree'``
+  being thrown from ``xml_serializer`` on certain cElementTree setups.
+  (Martin [gz], #254278)
+
 * strace test-helper tests cope with the new Ubuntu policy of not allowing
   users to attach to their own processes by default.
   (Martin Pool, #626679)
@@ -480,51 +449,9 @@
 
 * Upgrading or fetching from a non-rich-root repository to a rich-root
   repository (e.g. from pack-0.92 to 2a) no longer fails with
-  ``'Inter1and2Helper' object has no attribute 'source_repo'``.
-  (Andrew Bennetts, #636930)
+  ``'Inter1and2Helper' object has no attribute 'source_repo'``.  This was
+  a regression from Bazaar 2.1.  (Andrew Bennetts, #636930)
   
-* Wait for the SSH server to actually finish, rather than just waiting for
-  it to negotiate the key exchange. (John Arbash Meinel, #626876)
-
-Improvements
-************
-
-* ``bzr remove`` now just backs up changed files instead of exiting,
-  forcing you to choose to either keep or delete them. Bazaar will now delete
-  the files if they can easily be recovered using revert, otherwise they
-  will be backed up (adding an extention of the form .~#~).
-  (Marius Kruger, #400554)
-
-* ``bzr revert`` and ``bzr status`` are up to 15% faster on large trees
-  with many changes by not repeatedly building a list of all file-ids.
-  (Andrew Bennetts)
-
-* Decrease memory consumption when many chk index pages are loaded. (Such
-  as during ``bzr co`` or ``bzr ls -R`` of a large tree.) Often we need to
-  read many chk pages because the individual chk map nodes will be spread
-  randomly. Peak memory for 'bzr ls -R' on a large tree dropped from 396MB
-  down to 247MB, expect even more significant savings on 64-bit platforms.
-  (John Arbash Meinel)
-
-* ``DirState`` internals use a little bit less memory. For bzr.dev it
-  drops the memory from 1MB down to about 800kB. And replaces a few
-  thousand tuples and sets with StaticTuple.  (John Arbash Meinel)
-
-* Inventory entries now consume less memory (on 32-bit Ubuntu file entries
-  have dropped from 68 bytes to 40, and directory entries from 120 bytes
-  to 48).  (Andrew Bennetts)
-
-* When building new working trees, default to reading from the repository
-  rather than the source tree unless explicitly requested. (via
-  ``--files-from`` and ``--hardlink`` for ``bzr branch`` and
-  ``bzr checkout``. Generally, 2a format repositories extract
-  content faster than seeking and reading content from another tree,
-  especially in cold-cache situations. (John Arbash Meinel, #607298)
-
-* Add ``__pycache__`` to the default ``ignores`` file. Future releases of
-  Python will use this directory to store bytecodes.
-  (Andrea Corbellini, #626687)
-
 Documentation
 *************
 
@@ -543,6 +470,46 @@
 API Changes
 ***********
 
+* When passing a file to ``UTF8DirReader`` make sure to close the current
+  directory file handle after the chdir fails. Otherwise when passing many
+  filenames into a command line ``bzr status`` we would leak descriptors.
+  (John Arbash Meinel, #583486)
+
+* `ControlDirFormat` and  `ControlDir` have been split out of `BzrDirFormat`
+  and `BzrDir`, respectively. `ControlDirFormat`
+  and `ControlDir` should be used as the base classes for new non-.bzr
+  implementations.
+
+  `BzrDirFormat.register_control_format` has been renamed to
+  `ControlDirFormat.register_format`.
+
+  `BzrDirFormat.register_server_control_format` has been removed.
+
+  Probing for control directories is now done by separate objects derived
+  from `bzrlib.controldir.Prober` and registered using
+  `bzrlib.controldir.ControlDirFormat.register_prober` or
+  `bzrlib.controldir.ControlDirFormat.register_server_prober`.
+  `BzrDirFormat.probe_transport` has been moved onto `Prober`.
+
+  `BzrDirFormat.register_format` has been renamed to
+  `BzrProber.register_bzrdir_format`.
+
+  `bzrlib.bzrdir.network_format_registry` has been moved to
+  `bzrlib.controldir`.
+
+  (Jelmer Vernooij)
+
+* ``bzrlib.transform.TreeTransformBase.final_kind``,
+  ``bzrlib.transform.TreeTransform.tree_kind`` and
+  ``bzrlib.transform.TransformPreview.tree_kind`` now return None instead
+  of raising NoSuchFile.  (Vincent Ladeuil)
+
+* BzrError subclasses no longer support the name "message" to be used
+  as an argument for __init__ or in _fmt format specification as this
+  breaks in some Python versions. errors.LockError.__init__ argument
+  is now named "msg" instead of earlier "message".
+  (Parth Malwankar, #603461)
+
 * Configuration files should now use the ``from_string`` constructor rather
   than the ``file`` parameter of the ``_get_parser`` method. The later has
   been deprecated. ``from_string`` also accept a ``save=True`` parameter to
@@ -552,7 +519,11 @@
 * Deprecate treating a `PushResult` and `PullResult` as an integer for the
   relative change in revno.
   (Martin Pool)
-  `
+
+* `FileInWrongBranch` is deprecated in favour of `PathNotChild` and no
+  longer raised.
+  (Martin Pool)
+
 * ``IniBaseConfig`` objects should now use the ``from_string`` constructor
   the rather than the ``file`` parameter of the ``_get_parser`` method. The
   later has been deprecated. (Vincent Ladeuil)
@@ -573,6 +544,10 @@
   constructor has been deprecated, use the ``file_name`` parameter instead.
   (Vincent Ladeuil)
 
+* `tree_files` and `internal_tree_files` are now deprecated in favor of
+  `WorkingTree.open_containing_paths`.
+  (Martin Pool)
+
 Internals
 *********
 
@@ -582,6 +557,10 @@
 Testing
 *******
 
+* Avoid spurious failures in ssh tests: wait for the SSH server to
+  actually finish, rather than just waiting for it to negotiate the key
+  exchange. (John Arbash Meinel, #626876)
+
 * ``build_tree_contents`` can create symlinks.
   (Martin Pool, John Arbash Meinel)
 
@@ -598,6 +577,11 @@
 * Rearrange thread leak detection code to eliminate global state and make it
   possible to extend the reporting. (Martin [gz], #633462)
 
+* The old ``bzr selftest --benchmark`` option has been removed.
+  <https://launchpad.net/bzr-usertest> is an actively-maintained
+  macrobenchmark suite.
+  (Martin Pool)
+
 * The test suite now simply holds log files in memory, rather than writing them
   out to disk and then reading them back in and deleting them.
   (Andrew Bennetts)

=== added file 'doc/en/release-notes/release-template.txt'
--- doc/en/release-notes/release-template.txt	1970-01-01 00:00:00 +0000
+++ doc/en/release-notes/release-template.txt	2010-10-13 08:08:58 +0000
@@ -0,0 +1,53 @@
+bzr ?.?.?
+#########
+
+:Codename: Nirvana
+:2.x.y: NOT RELEASED YET
+
+External Compatibility Breaks
+*****************************
+
+.. These may require users to change the way they use Bazaar.
+
+New Features
+************
+
+.. New commands, options, etc that users may wish to try out.
+
+Improvements
+************
+
+.. Improvements to existing commands, especially improved performance 
+   or memory usage, or better results.
+
+Bug Fixes
+*********
+
+.. Fixes for situations where bzr would previously crash or give incorrect
+   or undesirable results.
+
+Documentation
+*************
+
+.. Improved or updated documentation.
+
+API Changes
+***********
+
+.. Changes that may require updates in plugins or other code that uses
+   bzrlib.
+
+Internals
+*********
+
+.. Major internal changes, unlikely to be visible to users or plugin 
+   developers, but interesting for bzr developers.
+
+Testing
+*******
+
+.. Fixes and changes that are only relevant to bzr's test framework and 
+   suite.  This can include new facilities for writing tests, fixes to 
+   spurious test failures and changes to the way things should be tested.
+
+

=== removed file 'doc/en/release-notes/release-template.txt'
--- doc/en/release-notes/release-template.txt	2010-10-13 06:04:10 +0000
+++ doc/en/release-notes/release-template.txt	1970-01-01 00:00:00 +0000
@@ -1,31 +0,0 @@
-bzr ?.?.?
-#########
-
-:Codename: Nirvana
-:2.x.y: NOT RELEASED YET
-
-Compatibility Breaks
-********************
-
-New Features
-************
-
-Bug Fixes
-*********
-
-Improvements
-************
-
-Documentation
-*************
-
-API Changes
-***********
-
-Internals
-*********
-
-Testing
-*******
-
-

=== modified file 'doc/en/release-notes/series-template.txt'
--- doc/en/release-notes/series-template.txt	2010-10-13 06:04:10 +0000
+++ doc/en/release-notes/series-template.txt	2010-10-13 08:08:58 +0000
@@ -11,30 +11,52 @@
 :Codename: Nirvana
 :2.x.y: NOT RELEASED YET
 
-Compatibility Breaks
-********************
+External Compatibility Breaks
+*****************************
+
+.. These may require users to change the way they use Bazaar.
 
 New Features
 ************
 
+.. New commands, options, etc that users may wish to try out.
+
+Improvements
+************
+
+.. Improvements to existing commands, especially improved performance 
+   or memory usage, or better results.
+
 Bug Fixes
 *********
 
-Improvements
-************
+.. Fixes for situations where bzr would previously crash or give incorrect
+   or undesirable results.
 
 Documentation
 *************
 
+.. Improved or updated documentation.
+
 API Changes
 ***********
 
+.. Changes that may require updates in plugins or other code that uses
+   bzrlib.
+
 Internals
 *********
 
+.. Major internal changes, unlikely to be visible to users or plugin 
+   developers, but interesting for bzr developers.
+
 Testing
 *******
 
+.. Fixes and changes that are only relevant to bzr's test framework and 
+   suite.  This can include new facilities for writing tests, fixes to 
+   spurious test failures and changes to the way things should be tested.
+
 
 ..
    vim: tw=74 ft=rst ff=unix

=== modified file 'doc/en/whats-new/whats-new-in-2.3.txt'
--- doc/en/whats-new/whats-new-in-2.3.txt	2010-10-06 04:14:52 +0000
+++ doc/en/whats-new/whats-new-in-2.3.txt	2010-10-13 07:04:50 +0000
@@ -98,6 +98,17 @@
   (Vincent Ladeuil, #219334)
 
 
+Expected releases for the 2.3 series
+************************************
+
+The 2.3 series has entered the beta phase and 2.3.0 should be released soon
+enough to be included into Natty Narwhal. 
+
+As a rough estimate, consider that 2.3.0 will be released in February
+2011 and be supported until August 2012. Additional releases will be
+made if critical bugs are encountered
+
+
 Further information
 *******************
 

